#include <iostream>
#include <string>
#include <stdlib.h>
#include <assert.h>
#include "pilha.h"
using namespace std;

bool ehAbre(char c) {
   return c == '(' || c == '[';
}

bool encaixa(char abre, char fecha) {
   return (abre == '(' && fecha == ')') ||
          (abre == '[' && fecha == ']');
}

void bemFormada (char s[]) {
   PILHA pilha;
   inicializa(&pilha);

   for (int i = 0; s[i] != '\0'; ++i) {
      if(ehAbre(s[i])) {
         empilha(&pilha, &s[i]);
      } else { // eh fecha
         if(vazia(&pilha)) {
            cout << "mal formada" << endl;
            return;
         }

         char c_topo = *((char*)topo(&pilha));

         if(encaixa(c_topo, s[i])) {
            desempilha(&pilha);
         } else {
            cout << "mal formada" << endl;
            return;
         }
      }
   }

   if(vazia(&pilha)) {
      cout << "bem formada \\o/" << endl;
   } else {
      cout << "mal formada" << endl;
   }
}

int main() {
   char s[500];
   gets(s);
   bemFormada(s);
}
